.\" -*- nroff -*-
.\"
.\" Copyright (c) 1996 Doug Rabson
.\"
.\" All rights reserved.
.\"
.\" This program is free software.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/VFS_FHTOVP.9,v 1.1.2.1 1999/09/05 11:27:12 peter Exp $
.\"
.Dd July 24, 1996
.Os
.Dt VFS_FHTOVP 9
.Sh NAME
.Nm VFS_FHTOVP
.Nd turn an NFS filehandle into a vnode
.Sh SYNOPSIS
.Fd #include <sys/mount.h>
.Fd #include <sys/vnode.h>
.Ft int
.Fn VFS_FHTOVP "struct mount *mp" "struct fid *fhp" "struct mbuf  *nam" "struct vnode **vpp" "int *exflagsp" "struct ucred **credanonp"
.Sh DESCRIPTION
This is used by the NFS server to turn an NFS filehandle into a vnode.
.Pp
Its arguments are:
.Bl -tag -width credanonp
.It Ar mp
The filesystem.
.It Ar fhp
The filehandle to convert.
.It Ar nam
An mbuf containing the network address of the client.
.It Ar vpp
Return parameter for the new locked vnode.
.It Ar exflagsp
Return parameter for the export flags for this client.
.It Ar credanonp
Return parameter for the anonymous credentials for this client.
.El
.Pp
The contents of the filehandle are defined by the filesystem and are
not examined by any other part of the system.  It should contain
enough information to uniquely identify a file within the filesystem
as well as noticing when a file has been removed and the filesystem
resources have been reused for a new file.  For instance, UFS
filesystem stores the inode number and inode generation counter in its
filehandle.
.Pp
The filesystem should call
.Xr vfs_export_lookup 9
with the address of an appropriate
.Dv netexport 
structure and the address of the client,
.Fa nam ,
to verify that the client can access this filesystem.
.Sh RETURN VALUES
The locked vnode for the file will be returned in
.Fa *vpp .
The export flags and anonymous credentials specific to the client
(returned by
.Xr vfs_export_lookup 9 )
will be returned in
.Fa *exflagsp
and
.Fa *credanonp .
.Sh SEE ALSO
.Xr vnode 9 ,
.Xr VFS 9 ,
.Xr VFS_VPTOFH 9
.Sh AUTHORS
This man page was written by Doug Rabson.

